Publish time 2011-12-15 01:22:26

[2012.05.14] How To Install Transmissin BT Client

If we want to use the transmission, we must pre install some software.Like below command.
I suggest the people can install the rtorrent+rutorrent first, if  the transmission can't work fine, there are no cross-reference to let reader debug issue.
sudo apt-get install build-essential automake autoconf libtool pkg-config intltool libcurl4-openssl-dev libglib2.0-dev libevent-dev libminiupnpc-dev libminiupnpc5 libappindicator-dev
Then, we must download the transmission source code.
http://www.transmissionbt.com/download/

For example, we will install Transmission version 2.51
wget http://download.transmissionbt.com/files/transmission-2.51.tar.bz2
tar xvjf transmission-2.51.tar.bz2

Then,we download and install the new version of libevent and intltool.
wget https://github.com/downloads/libevent/libevent/libevent-2.0.16-stable.tar.gz
cd libevent-2.0.16-stable
./configure&&make&&sudo make install
sudo apt-get install intltool
(The command can check the packet of intltool packet : sudo apt-cache show intltool)

Then, we can complete to install transmission
./configure -q && make -s
sudo make install

After we install the transmission, we need to create the environment to let transmission work fine.
mkdir tm tm-temp tm-torrents
sudo ldconfig
transmission-daemon -f
ctrl^c

People can refer the rtorrent installing tutorial to know why we create the folders - tm & tm-temp & tm-torrents.
Then we need write the script to control transmission state when we execute the transmission and restart the system.
First, we write the initial script can let transmission auto execute when we start the ubuntu system.
sudo vi /etc/init.d/transmission-daemon
#! /bin/sh
### BEGIN INIT INFO
# Provides:          transmission-daemon
# Required-Start:    networking
# Required-Stop:     networking
# Default-Start:     2 3 5
# Default-Stop:      0 1 6
# Short-Description: Start the transmission BitTorrent daemon client.
### END INIT INFO

# Original Author: Lennart A. JÃŒtte, based on Rob Howell's script
# Modified by Maarten Van Coile & others (on IRC)

# Do NOT "set -e"

#
# ----- CONFIGURATION -----
#
# For the default location Transmission uses, visit:
# http://trac.transmissionbt.com/wiki/ConfigFiles
# For a guide on how set the preferences, visit:
# http://trac.transmissionbt.com/wiki/EditConfigFiles
# For the available environement variables, visit:
# http://trac.transmissionbt.com/wiki/EnvironmentVariables
#
# The name of the user that should run Transmission.
# It's RECOMENDED to run Transmission in it's own user,
# by default, this is set to 'transmission'.
# For the sake of security you shouldn't set a password
# on this user
USERNAME=*


# ----- *ADVANCED* CONFIGURATION -----
# Only change these options if you know what you are doing!
#
# The folder where Transmission stores the config & web files.
# ONLY change this you have it at a non-default location
#TRANSMISSION_HOME="/var/config/transmission-daemon"
#TRANSMISSION_WEB_HOME="/usr/share/transmission/web"
#
# The arguments passed on to transmission-daemon.
# ONLY change this you need to, otherwise use the
# settings file as per above.
#TRANSMISSION_ARGS=""


# ----- END OF CONFIGURATION -----
#
# PATH should only include /usr/* if it runs after the mountnfs.sh script.
PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
DESC="bittorrent client"
NAME=transmission-daemon
DAEMON=$(which $NAME)
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS

#
# Function that starts the daemon/service
#

do_start()
{
    # Export the configuration/web directory, if set
    if [ -n "$TRANSMISSION_HOME" ]; then
          export TRANSMISSION_HOME
    fi
    if [ -n "$TRANSMISSION_WEB_HOME" ]; then
          export TRANSMISSION_WEB_HOME
    fi

    # Return
    #   0 if daemon has been started
    #   1 if daemon was already running
    #   2 if daemon could not be started
    start-stop-daemon --chuid $USERNAME --start --pidfile $PIDFILE --make-pidfile \
            --exec $DAEMON --background --test -- -f $TRANSMISSION_ARGS > /dev/null \
            || return 1
    start-stop-daemon --chuid $USERNAME --start --pidfile $PIDFILE --make-pidfile \
            --exec $DAEMON --background -- -f $TRANSMISSION_ARGS \
            || return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
        # Return
        #   0 if daemon has been stopped
        #   1 if daemon was already stopped
        #   2 if daemon could not be stopped
        #   other if a failure occurred
        
    start-stop-daemon --stop --quiet --retry=TERM/10/KILL/5 --pidfile $PIDFILE --exec $DAEMON
    RETVAL="$?"
        [ "$RETVAL" = 2 ] && return 2

        # Wait for children to finish too if this is a daemon that forks
        # and if the daemon is only ever run from this initscript.
        # If the above conditions are not satisfied then add some other code
        # that waits for the process to drop all resources that could be
        # needed by services started subsequently.  A last resort is to
        # sleep for some time.

        start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
        [ "$?" = 2 ] && return 2

        # Many daemons don't delete their pidfiles when they exit.
        rm -f $PIDFILE

        return "$RETVAL"
}

case "$1" in
  start)
        echo "Starting $DESC" "$NAME..."
        do_start
        case "$?" in
                0|1) echo "   Starting $DESC $NAME succeeded" ;;
                *)   echo "   Starting $DESC $NAME failed" ;;
        esac
        ;;
  stop)
        echo "Stopping $DESC $NAME..."
        do_stop
        case "$?" in
                0|1) echo "   Stopping $DESC $NAME succeeded" ;;
                *)   echo "   Stopping $DESC $NAME failed" ;;
        esac
        ;;
  restart|force-reload)
        #
        # If the "reload" option is implemented then remove the
        # 'force-reload' alias
        #
        echo "Restarting $DESC $NAME..."
        do_stop
        case "$?" in
          0|1)
                do_start
                case "$?" in
                    0|1) echo "   Restarting $DESC $NAME succeeded" ;;
                    *)   echo "   Restarting $DESC $NAME failed: couldn't start $NAME" ;;
                esac
                ;;
          *)
                echo "   Restarting $DESC $NAME failed: couldn't stop $NAME" ;;
        esac
        ;;
  *)
        echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
        exit 3
        ;;
esac
People must pay attenttion that the content of the script is different with the official provide, please use the script I provide.
And, people need change the content of * in line 31 to your real username, you can refer the home directory.

Second, we want to edit the configuration file.
vi ~/.config/transmission-daemon/settings.json{
    "alt-speed-down": 7000,
    "alt-speed-enabled": false,
    "alt-speed-time-begin": 540,
    "alt-speed-time-day": 217,
    "alt-speed-time-enabled": false,
    "alt-speed-time-end": 1020,
    "alt-speed-up": 15000,
    "bind-address-ipv4": "***",
    "bind-address-ipv6": "***",
    "blocklist-enabled": false,
    "blocklist-url": "http://www.example.com/blocklist",
    "cache-size-mb": 15,
    "dht-enabled": true,
    "download-dir": "/home/***/tm",
    "download-queue-enabled": true,
    "download-queue-size": 15,
    "encryption": 1,
    "idle-seeding-limit": 30,
    "idle-seeding-limit-enabled": false,
    "incomplete-dir": "/home/***/tm-temp",
    "incomplete-dir-enabled": true,
    "lazy-bitfield-enabled": true,
    "lpd-enabled": false,
    "message-level": 2,
    "peer-congestion-algorithm": "",
    "peer-limit-global": 1000,
    "peer-limit-per-torrent": 100,
    "peer-port": 35770,
    "peer-port-random-high": 42424,
    "peer-port-random-low": 4242,
    "peer-port-random-on-start": true,
    "peer-socket-tos": "default",
    "pex-enabled": true,
    "port-forwarding-enabled": true,
    "preallocation": 1,
    "prefetch-enabled": 1,
    "queue-stalled-enabled": true,
    "queue-stalled-minutes": 60,
    "ratio-limit": 10,
    "ratio-limit-enabled": false,
    "rename-partial-files": true,
    "rpc-authentication-required": true,
    "rpc-bind-address": "***",
    "rpc-enabled": true,
    "rpc-password": "***",
    "rpc-port": 4242,
    "rpc-url": "/***/",
    "rpc-username": "goddesschi",
    "rpc-whitelist": "***",
    "rpc-whitelist-enabled": false,
    "scrape-paused-torrents-enabled": true,
    "script-torrent-done-enabled": false,
    "script-torrent-done-filename": "",
    "seed-queue-enabled": true,
    "seed-queue-size": 15,
    "speed-limit-down": 7000,
    "speed-limit-down-enabled": true,
    "speed-limit-up": 15000,
    "speed-limit-up-enabled": false,
    "start-added-torrents": true,
    "trash-original-torrent-files": false,
    "umask": 22,
    "upload-slots-per-torrent": 5,
    "utp-enabled": true,
    "watch-dir": "/home/***/tm-torrents",
    "watch-dir-enabled": true
}
About the above script, search *** and change the content to fit your environment or your like.
People can refer the official website to get explaination of the parameter.

BTW, when people change password can reload the setting by this caomand.
pkill -HUP transmission-da

Then, we execute the command and we can use thetransmission
transmission-daemon or
sudo /etc/init.d/transmission-daemon restart

if you want to see the web ui, put the internet site in your web browser and enter.
See your script setting to get informationrpc-bind-address、rpc-port and rpc-url.http://rpc-bind-address:rpc-port/rpc-url

Final, if you want to upgrade the transmission,  I suggest you remove the old transmission and install new version source code again.
For example, I remove the 2.42 version and install the 2.5 version
cd transmission-2.42
sudo make uninstall
sudo make clean
cd ..
wget http://download.transmissionbt.com/files/transmission-2.51.tar.bz2
tar xvjf transmission-2.51.tar.bz2
cd transmission-2.51
./configure -q && make -s
sudo make install
transmission-daemonSo,  after you install the software finished, remember don't remove the complier source code.
When you wnat to upgrade the transmission and you want make uninstall, you need to use the source code.
Pages: [1]
View full version: [2012.05.14] How To Install Transmissin BT Client